<script lang="ts" setup>
// The Showcase-Card portion of this grid is very similar to the Community page's CardGrid and some CommonCards, but still has its own unique styles
import type { BaseCard } from '@/types/base';
import {
  ArrowRight,
  CollaborationAlt4,
  Increase,
  DigitalTransformation,
  Community,
  ContinuousDelivery,
  OpenBook,
} from 'slippers-ui/icons';

enum CardType {
  resource = 'resource',
  common = 'common',
}

interface CardGridProps {
  title?: string;
  cards: Array<BaseCard>;
  config: {
    backgroundColor?: string;
    cardType: CardType;
  };
}

defineProps<CardGridProps>();

const icons = {
  CollaborationAlt4,
  Increase,
  DigitalTransformation,
  Community,
  ContinuousDelivery,
  OpenBook,
};
</script>

<template>
  <SlpSection
    class="card-grid"
    :background-color="config.backgroundColor ? config.backgroundColor : '$color-surface-50'"
  >
    <div v-if="title" class="showcase__gradient-header" />
    <SlpTypography v-if="title" tag="h2" variant="heading2-bold">
      {{ title }}
    </SlpTypography>
    <SlpRow ref="cards" class="slp-mb-md-94 slp-mb-64 cards">
      <SlpColumn v-for="card in cards" :key="card.title" :cols="4">
        <CommonResourceCard v-if="config.cardType == 'resource'" v-bind="card" class="resource-card" />
        <a
          v-else-if="config.cardType == 'common'"
          class="showcase-card"
          :href="card.button.config.href"
          :data-ga-name="card.button.config.dataGaName || card.title.toLowerCase()"
          :data-ga-location="card.button.config.dataGaName || body"
        >
          <div class="header">
            <SlpIcon :icon="icons[card.icon.config.name]" size="lg" />
            <SlpTypography variant="heading5-bold">
              {{ card.title }}
            </SlpTypography>
          </div>
          <SlpTypography variant="body3">
            {{ card.text }}
          </SlpTypography>
          <SlpIcon class="arrow-icon" :icon="ArrowRight" variant="product" size="sm" />
        </a>
      </SlpColumn>
    </SlpRow>
  </SlpSection>
</template>

<style lang="scss" scoped>
.content {
  height: 100%;
  display: flex;
  flex-direction: column;
}

.card-grid {
  padding: $spacing-96 0;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  h2 {
    margin-bottom: $spacing-64;
  }

  .slp-col-md-4 {
    padding: 0 $spacing-16 $spacing-16 0;
  }
}

.cards {
  position: relative;
}

.showcase__gradient-header {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
  margin-bottom: $spacing-16;
}

.resource-card {
  :deep(.resources-card__cta) {
    color: $color-text-link-100;
  }

  :deep(.slp-icon) {
    fill: $color-text-link-100 !important;
    color: $color-text-link-100;
  }
}

.showcase-card {
  cursor: pointer;
  display: flex;
  flex-direction: column;
  gap: 24px;
  padding: 24px;
  min-height: 300px;
  height: 100%;
  color: $color-text-300;
  background-color: $color-surface-50;
  border-radius: 4px;
  transition: all 0.3s;

  .header {
    display: flex;
    flex-direction: column;
    gap: 16px;
  }

  .arrow-icon {
    margin-top: auto;
  }

  &:hover {
    border-radius: 4px 4px 90px 4px;
  }
}

@media (max-width: $breakpoint-md) {
  .showcase-card {
    height: 100%;
    width: 270px;
    margin-right: 16px;
  }
}

@media (max-width: 767px) {
  .showcase-wrapper .slp-col-md-4 {
    padding-right: 0;
  }

  .cards {
    flex-wrap: nowrap;
    overflow-x: scroll;
    margin-bottom: 0;

    // Hide scrollbar across different browsers
    scrollbar-width: none;
    -ms-overflow-style: none;

    &::-webkit-scrollbar {
      width: 0;
      height: 0;
      display: none;
    }
  }
}
</style>
